local loGFX as xfcGraphics of Source\System.Drawing.PRG, ;
	loBrush as xfcBrush of Source\System.Drawing.PRG, ;
	loFont as xfcFont of Source\System.Drawing.PRG, ;
	loColor as xfcColor of Source\System.Drawing.PRG
local lnI, ;
	lnA, ;
	lnR, ;
	lnG, ;
	lnB, ;
	lnX, ;
	lnY, ;
	lcName

* Ensure GDIPlusX is available.

do System.app
clear
with _screen.System.Drawing as xfcDrawing of Source\System.PRG

* Create a Graphics object that draws on _SCREEN.

	loGfx = .Graphics.FromHWnd(_screen.HWnd)

* Seed the random number generator.

	rand(-1)

* Draw filled ellipses and rectangles of random colors and transparencies at
* random places on the screen.

	for lnI = 1 to 100
		lnA     = rand() * 255
		lnR     = rand() * 255
		lnG     = rand() * 255
		lnB     = rand() * 255
		loColor = .Color.FromARGB(lnA, lnR, lnG, lnB)
		loBrush = .SolidBrush.New(loColor)
		if mod(int(rand() * 100), 2) = 1
			loGfx.FillRectangle(loBrush, rand() * _screen.Width, ;
				rand() * _screen.Height, rand() * 200, rand() * 200)
		else
			loGfx.FillEllipse(loBrush, rand() * _screen.Width, ;
				rand() * _screen.Height, rand() * 200, rand() * 200)
		endif mod(int(rand() * 100), 2) = 1
	next lnI

* Wait for a keypress, then clear the screen.

	wait window
	clear

* Create a color chart. Start by creating a font object and starting X and Y
* values.

	loFont = .Font.New('Segoe UI', 10)
	lnX    = 0
	lnY    = 20
	for lnI = 1 to 174	&& there are 174 known colors

* Create a color object from the known color number and get its name.

		loColor = .Color.FromKnownColor(lnI)
		lcName  = loColor.Name

* Create a brush of the specified color and create a small filled rectangle.

		loBrush = .SolidBrush.New(loColor)
		loGfx.FillRectangle(loBrush, lnX, lnY, 10, 10)

* Draw the name of the color beside the rectangle.

		loGfx.DrawString(lcName, loFont, .Brushes.Black, lnX + 10, lnY - 4)

* Increment the Y position and every 30 colors, move to the next column.

		if lnI/30 = int(lnI/30)
			lnX = lnX + 150
			lnY = 20
		else
			lnY = lnY + 20
		endif lnI/30 = int(lnI/30)
	next lnI
endwith








