local loGFX as xfcGraphics of Source\System.Drawing.PRG, ;
	lcText, ;
	loFont as xfcFont of Source\System.Drawing.PRG, ;
	loRect as xfcRectangle of Source\System.Drawing.PRG, ;
	loStringFormat as xfcStringFormat of Source\System.Drawing.PRG, ;
	loBrush as xfcBrush of Source\System.Drawing.PRG

* Ensure GDIPlusX is available.

do System.app
clear
with _screen.System.Drawing as xfcDrawing of Source\System.PRG

* Create a Graphics object. We'll create it by calling FromHWnd and passing it
* the handle (HWnd) to _SCREEN, which means we'll be drawing directly on
* _SCREEN.

	loGfx = .Graphics.FromHWnd(_screen.HWnd)

* Use anti-aliasing for better results.

	loGfx.TextRenderingHint = .Drawing2D.SmoothingMode.AntiAlias

* The text to draw.

	lcText = 'This program demonstrates drawing text inside a rectangle'

* Create a font object. The New method of System.Drawing.Font creates a font
* object using specified font, size, and style. Note that style is specified as
* an enumeration; in this case, the Bold member of System.Drawing.FontStyle.

	loFont = .Font.New('Tahoma', 16, .FontStyle.Bold)

* Create a rectangle object to hold the dimensions we'll draw at.

	loRect = .Rectangle.New(10, 10, 200, 200)

* Create a red solid brush.

	loBrush = .SolidBrush.New(.Color.Red)

* Create a StringFormat object and specify center alignment both horizontally
* and vertically.

	loStringFormat               = .StringFormat.New()
	loStringFormat.Alignment     = .StringAlignment.Center
	loStringFormat.LineAlignment = .StringAlignment.Center

* Draw the text using the desired font and brush in the desired dimensions.

	loGfx.DrawString(lcText, loFont, loBrush, loRect, loStringFormat)

* Create a 2-pixel black pen.

	loPen = .Pen.New(.Color.Black, 2)
	
* Draw a rectangle using the pen at the desired location and size.

	loGfx.DrawRectangle(loPen, loRect)
endwith














