local loGFX as xfcGraphics of Source\System.Drawing.PRG, ;
	loRect as xfcRectangle of Source\System.Drawing.PRG, ;
	loBrush as xfcLinearGradientBrush of Source\System.Drawing.Drawing2D.PRG, ;
	loFont as xfcFont of Source\System.Drawing.PRG
local lnMode

* Ensure GDIPlusX is available.
 
do System.app
clear
with _screen.System.Drawing as xfcDrawing of Source\System.PRG

* Create a Graphics object that draws on _SCREEN.

	loGfx = .Graphics.FromHWnd(_screen.HWnd)

* Draw a rectangle with a gradient from red to white.

	loRect  = .Rectangle.New(50, 50, 300, 100)
	loBrush = .Drawing2D.LinearGradientBrush.New(loRect, .Color.Red, ;
		.Color.White)
	loGfx.FillRectangle(loBrush, loRect)

* Change the brush colors and draw a bigger rectangle.

	loBrush.LinearColors[1] = .Color.Blue
	loBrush.LinearColors[2] = .Color.Black
	loGfx.FillRectangle(loBrush, 50, 200, 500, 100)

* Wait for a keypress and clear the screen.

	wait window
	clear

* Create a font object.

	loFont = .Font.New('Segoe UI', 16)

* Show various gradient modes.

	lnMode  = .Drawing2D.LinearGradientMode.Horizontal
	loRect  = .Rectangle.New(50, 50, 200, 200)
	loBrush = .Drawing2D.LinearGradientBrush.New(loRect, .Color.Red, ;
		.Color.White, lnMode)
	loGfx.FillRectangle(loBrush, loRect)
	loGfx.DrawString('Horizontal', loFont, .Brushes.Black, 50, 50)

	lnMode  = .Drawing2D.LinearGradientMode.ForwardDiagonal
	loRect  = .Rectangle.New(300, 50, 200, 200)
	loBrush = .Drawing2D.LinearGradientBrush.New(loRect, .Color.Red, ;
		.Color.White, lnMode)
	loGfx.FillRectangle(loBrush, loRect)
	loGfx.DrawString('ForwardDiagonal', loFont, .Brushes.Black, 300, 50)

	lnMode  = .Drawing2D.LinearGradientMode.Vertical
	loRect  = .Rectangle.New(50, 300, 200, 200)
	loBrush = .Drawing2D.LinearGradientBrush.New(loRect, .Color.Red, ;
		.Color.White, lnMode)
	loGfx.FillRectangle(loBrush, loRect)
	loGfx.DrawString('Vertical', loFont, .Brushes.Black, 50, 300)

	lnMode  = .Drawing2D.LinearGradientMode.BackwardDiagonal
	loRect  = .Rectangle.New(300, 300, 200, 200)
	loBrush = .Drawing2D.LinearGradientBrush.New(loRect, .Color.Red, ;
		.Color.White, lnMode)
	loGfx.FillRectangle(loBrush, loRect)
	loGfx.DrawString('BackwardDiagonal', loFont, .Brushes.Black, 300, 300)

* Use an angle to customize how the transition works.

	loRect  = .Rectangle.New(50, 550, 200, 200)
	loBrush = .Drawing2D.LinearGradientBrush.New(loRect, ;
		.Color.Red, .Color.White, 225, .T.)
	loGfx.FillRectangle(loBrush, loRect)
	loGfx.DrawString('Custom (225)', loFont, .Brushes.Black, 50, 550)
endwith








