local loGFX as xfcGraphics of Source\System.Drawing.PRG, ;
	loPoint1 as xfcPoint of Source\System.Drawing.PRG, ;
	loPoint2 as xfcPoint of Source\System.Drawing.PRG, ;
	loRect as xfcRectangle of Source\System.Drawing.PRG, ;
	loRect2 as xfcRectangle of Source\System.Drawing.PRG

* Ensure GDIPlusX is available.

do System.app
clear
with _screen.System.Drawing as xfcDrawing of Source\System.PRG

* Create a Graphics object that draws on _SCREEN.

	loGfx = .Graphics.FromHWnd(_screen.HWnd)

* Draw a line using X and Y values.

	loGfx.DrawLine(.Pens.Black, 10, 10, 200, 200)

* Draw a line using a Point objects.

	loPoint1 = .Point.New(10, 20)
	loPoint2 = .Point.New(200, 210)
	loGfx.DrawLine(.Pens.Black, loPoint1, loPoint2)

* Draw a red rectangle using X, Y, height, and width values.

	loGfx.DrawRectangle(.Pens.Red, 20, 20, 420, 220)

* Draw a blue rectangle using a Rectangle object.

	loRect = .Rectangle.New(40, 40, 100, 100)
	loGfx.DrawRectangle(.Pens.Blue, loRect)

* Create a new rectangle and see if it's contained with the first one.

	loRect2 = .Rectangle.New(60, 60, 10, 10)
	messagebox('loRect2 ' + iif(loRect.Contains(loRect2), 'is', 'is not') + ;
		' contained in loRect')

* Create a rectangle that unions two others.

	loRect2 = .Rectangle.New(60, 60, 200, 200)
	loRect3 = loRect2.Union(loRect, loRect2)
	messagebox('Top: ' + transform(loRect3.Top) + chr(13) + ;
		'Left: ' + transform(loRect3.Left) + chr(13) + ;
		'Bottom: ' + transform(loRect3.Bottom) + chr(13) + ;
		'Right: ' + transform(loRect3.Right), 0, 'After Union')

* See if the rectangles intersect.

	messagebox('loRect and loRect2 ' + ;
		iif(loRect.IntersectsWith(loRect2), 'do', 'do not') + ' intersect')
endwith










