* Test the VFP version of GenerateThumbnail: draw an image at its original size
* and reduced by 50%.

clear
do System
with _screen.System.Drawing
	loBmp    = .Bitmap.FromFile('vfpx.bmp')
	loNewBmp = GenerateThumbnail(loBmp, 50)
	loGfx    = .Graphics.FromHWnd(_screen.HWnd)
	loGfx.DrawImage(loBmp, 10, 10, loBmp.Width, loBmp.Height)
	loGfx.DrawImage(loNewBmp, 10, 100, loNewBmp.Width, loNewBmp.Height)
endwith


* Here's the original code from http://www.bobpowell.net/highqualitythumb.htm

*Public Function GenerateThumbnail(original As Image, percentage As Integer) As Image
*	If percentage < 1 Then
*		Throw New Exception("Thumbnail size must be at least 1% of the original size")
*	End If
*	Dim tn As New Bitmap(CInt(original.Width * 0.01F * percentage), _
*		CInt(original.Height * 0.01F * percentage))
*	Dim g As Graphics = Graphics.FromImage(tn)
*	g.InterpolationMode = InterpolationMode.HighQualityBilinear	g.DrawImage(original, New Rectangle(0, 0, tn.Width, tn.Height), _
*		0, 0, original.Width, original.Height, GraphicsUnit.Pixel)
*	g.Dispose()
*	Return CType(tn, Image)
*End Function

* Here's the VFP equivalent, line by line.

*Public Function GenerateThumbnail(original As Image, percentage As Integer) As Image
function GenerateThumbnail(original, percentage)

*If percentage < 1 Then
*	Throw New Exception("Thumbnail size must be at least 1% of the original size")
*End If
if percentage < 1
	error "Thumbnail size must be at least 1% of the original size"
endif

* New code: ensure GDIPlusX is available.
do System
with _screen.System.Drawing as xfcDrawing of source\System.Drawing.prg
* End of new code

*	Dim tn As New Bitmap(CInt(original.Width * 0.01F * percentage), _
*		CInt(original.Height * 0.01F * percentage))
	tn = .Bitmap.New(int(original.Width * 0.01 * percentage), ;
		int(original.Height * 0.01 * percentage))

*	Dim g As Graphics = Graphics.FromImage(tn)
	gx = .Graphics.FromImage(tn)
		&& need different variable name because "g" looks like a workarea

*	g.InterpolationMode = InterpolationMode.HighQualityBilinear
	gx.InterpolationMode = .Drawing2D.InterpolationMode.HighQualityBilinear

*	g.DrawImage(original, New Rectangle(0, 0, tn.Width, tn.Height), _
*		0, 0, original.Width, original.Height, GraphicsUnit.Pixel)
	gx.DrawImage(original, .Rectangle.New(0, 0, tn.Width, tn.Height), ;
		0, 0, original.Width, original.Height, .GraphicsUnit.Pixel)

*	g.Dispose()
	gx.Dispose()

* New code: finish WITH
endwith
* End of new code

*Return CType(tn, Image)
return tn

*End Function
endfunc
